/*
  CPP_CONTEST=2013
  CPP_PROBLEM=E
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=mercurio 1
*/

#include <stdlib.h>
#include <stdio.h>
#include <helper_functions.h>
#include <helper_cuda.h>
 
double onetaylor(int N,double *a,double x,double y)
{
  int i,j;
  double *v,r=0;

  v=(double *) malloc(sizeof(double)*N*N);

  v[0]=1;
  for(i=1;i<N;i++)
    v[i]=v[i-1]/y;
  for(i=1;i<N;i++)
  {
    v[i*N]=v[(i-1)*N]/x;
    for(j=1;j<N-i;j++)
      v[i*N+j]=v[i*N+j-1]/y;
  }
  for(i=0;i<N;i++)
  {
    for(j=0;j<N-i;j++)
      r+=a[i*N+j]*v[i*N+j];
  }
  free(v);
  return r;
}
    
void  sec(int N,double *a,int P,double *x,double *y,double *r)
{
  int i;

  for(i=0;i<P*P;i++)
  {
     r[i]=onetaylor(N,a,x[i],y[i]);
  }
}

