/*
  CPP_CONTEST=2013
  CPP_PROBLEM=B
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 1
*/

// 1

#include <stdlib.h>
#include <omp.h>
#include <mpi.h>
 
void accumulatelocal(int *a,int N,int v,int r1,int c1,int r2,int c2)
{
  int i,j;
  int *pos;

  for(i=r1;i<=r2;i++)
  {
    pos=&a[i*N];
    for(j=c1;j<=c2;j++)
    {
      pos[j]+=v;
    }
  }
}
    
void  sec(int N,int M,int *a,int *value,int *r1,int *c1,int *r2,int *c2)
{
  int i;

  for(i=0;i<M;i++)
  {
     accumulatelocal(a,N,value[i],r1[i],c1[i],r2[i],c2[i]);
  }
}

